"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutPropertiesLoose"));

var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));

var _inheritsLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _reshowFlux = require("reshow-flux");

var _reactAtomicMolecule = require("react-atomic-molecule");

var _scrollStore = _interopRequireDefault(require("../../src/stores/scrollStore"));

var _fastScrollStore = _interopRequireDefault(require("../../src/stores/fastScrollStore"));

var ScrollReceiver = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(ScrollReceiver, _Component);

  function ScrollReceiver() {
    return _Component.apply(this, arguments) || this;
  }

  ScrollReceiver.getStores = function getStores(props) {
    return props.noDelay ? [_fastScrollStore["default"]] : [_scrollStore["default"]];
  };

  ScrollReceiver.calculateState = function calculateState(prevState, props) {
    var noDelay = props.noDelay,
        targetId = props.targetId,
        scrollMargin = props.scrollMargin;
    var store = noDelay ? _fastScrollStore["default"] : _scrollStore["default"];
    var state = store.getState();
    var isShown = prevState && prevState.isShown || false;
    var pos = store.getOffset(targetId, store.storeName) || {};
    var scrollInfo = store.getMap('scroll');
    var scrollTop = scrollInfo.top;

    if (pos.isOnScreen) {
      isShown = true;
    }

    var active = 'undefined' !== typeof targetId && targetId === state.get('m' + scrollMargin);

    if (!isNaN(scrollMargin)) {
      store.addMargin(scrollMargin);
    }

    return (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, pos), {}, {
      active: active,
      scrollTop: scrollTop,
      scrollInfo: scrollInfo,
      isShown: isShown
    });
  };

  var _proto = ScrollReceiver.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        atom = _this$props.atom,
        container = _this$props.container,
        scrollMargin = _this$props.scrollMargin,
        targetId = _this$props.targetId,
        isScrollReceiver = _this$props.isScrollReceiver,
        noDelay = _this$props.noDelay,
        children = _this$props.children,
        resetProps = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["atom", "container", "scrollMargin", "targetId", "isScrollReceiver", "noDelay", "children"]);

    if (!container) {
      return /*#__PURE__*/_react["default"].createElement(_reactAtomicMolecule.SemanticUI, resetProps, children);
    }

    var targetInfo = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, this.state), {}, {
      targetId: targetId
    });
    var thisChildren = children;

    if (!thisChildren && /*#__PURE__*/(0, _react.isValidElement)(container)) {
      thisChildren = container.props.children;
    }

    return (0, _reactAtomicMolecule.build)(container)((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, resetProps), {}, {
      targetInfo: targetInfo
    }), thisChildren);
  };

  return ScrollReceiver;
}(_react.Component);

(0, _defineProperty2["default"])(ScrollReceiver, "defaultProps", {
  scrollMargin: 'default',
  isScrollReceiver: true,
  noDelay: false
});

var _default = (0, _reshowFlux.connect)(ScrollReceiver, {
  withProps: true
});

exports["default"] = _default;
module.exports = exports.default;