"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("reshow-runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _getObjectValue = _interopRequireDefault(require("get-object-value"));

var _reactAtomicMolecule = require("react-atomic-molecule");

var _scrollStore = _interopRequireDefault(require("../../src/stores/scrollStore"));

var _fastScrollStore = _interopRequireDefault(require("../../src/stores/fastScrollStore"));

var _ref = /*#__PURE__*/_react["default"].createElement(_reactAtomicMolecule.SemanticUI, null);

var ScrollSpy = /*#__PURE__*/function (_PureComponent) {
  (0, _inheritsLoose2["default"])(ScrollSpy, _PureComponent);

  function ScrollSpy() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _PureComponent.call.apply(_PureComponent, [this].concat(args)) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {});
    return _this;
  }

  var _proto = ScrollSpy.prototype;

  _proto.getOffsetEl = function getOffsetEl() {
    if (this.el) {
      return this.el;
    } else {
      console.warn('Please use SemanticUI. props.container -> import {SemanticUI} from "react-atomic-molecule"');
    }
  };

  _proto.useStore = function useStore() {
    var noDelay = this.props.noDelay;
    return noDelay ? _fastScrollStore["default"] : _scrollStore["default"];
  };

  _proto.attach = function attach() {
    if (this.useStore().hasAttach(this)) {
      return this.state.id;
    }

    var id = this.useStore().attach(this);
    this.setState({
      id: id
    });
    return id;
  };

  _proto.detach = function detach() {
    return this.useStore().detach(this);
  };

  _proto.isScrollReceiver = function isScrollReceiver(el) {
    if ((0, _getObjectValue["default"])(el, ['props', 'isScrollReceiver'])) {
      return true;
    }

    return false;
  };

  _proto.componentDidMount = function componentDidMount() {
    this.attach();
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.detach();
  };

  _proto.render = function render() {
    var _this2 = this;

    /**
     * monitorScroll use in store, in component just for reset props.
     */
    var _this$props = this.props,
        className = _this$props.className,
        monitorScroll = _this$props.monitorScroll,
        children = _this$props.children,
        container = _this$props.container,
        noDelay = _this$props.noDelay,
        others = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["className", "monitorScroll", "children", "container", "noDelay"]);
    var isScrollReceiver = this.isScrollReceiver(children);
    var targetId = this.state.id;
    var classes = (0, _reactAtomicMolecule.mixClass)(className, 'spy-tar-' + targetId);
    var cookChildren;
    var thisContainer;
    var thisProps;

    if (isScrollReceiver) {
      thisContainer = children;
      thisProps = (0, _objectSpread2["default"])((0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, others), children.props), {}, {
        className: classes,
        targetId: targetId,
        container: container,
        noDelay: noDelay
      });
    } else {
      thisProps = (0, _objectSpread2["default"])({
        children: children,
        className: classes
      }, others);

      if (container) {
        thisContainer = container;
      } else {
        thisContainer = _ref;
      }
    }

    thisProps = (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, thisProps), {}, {
      refCb: function refCb(el) {
        return _this2.el = el;
      }
    });
    return /*#__PURE__*/_react["default"].cloneElement(thisContainer, thisProps);
  };

  return ScrollSpy;
}(_react.PureComponent);

(0, _defineProperty2["default"])(ScrollSpy, "defaultProps", {
  monitorScroll: true,
  noDelay: false
});
var _default = ScrollSpy;
exports["default"] = _default;
module.exports = exports.default;