"use strict";

var _interopRequireWildcard = require("reshow-runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("reshow-runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("reshow-runtime/helpers/extends"));

var _objectSpread2 = _interopRequireDefault(require("reshow-runtime/helpers/objectSpread2"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("reshow-runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("reshow-runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("reshow-runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _smoothScrollTo = _interopRequireDefault(require("smooth-scroll-to"));

var _getoffset = _interopRequireDefault(require("getoffset"));

var _index = require("../../src/index");

var _scrollStore = _interopRequireDefault(require("../../src/stores/scrollStore"));

var _fastScrollStore = _interopRequireDefault(require("../../src/stores/fastScrollStore"));

var scollTimer = null;

var resetTimer = function resetTimer() {
  if (scollTimer) {
    clearTimeout(scollTimer);
    scollTimer = false;
  }
};

var SmoothScrollLink = /*#__PURE__*/function (_PureComponent) {
  (0, _inheritsLoose2["default"])(SmoothScrollLink, _PureComponent);

  function SmoothScrollLink() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _PureComponent.call.apply(_PureComponent, [this].concat(args)) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      scrollRefElement: null
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClick", function (e) {
      var props = _this.props;

      var store = _this.useStore();

      var preventDefault = props.preventDefault,
          targetId = props.targetId;
      var scrollRefElement = _this.state.scrollRefElement;

      if (preventDefault) {
        e.preventDefault();
      }

      resetTimer();
      var offset = store.getOffset(targetId);

      if (offset) {
        var margin = _this.getMargin(props, scrollRefElement);

        scollTimer = true;
        (0, _smoothScrollTo["default"])(offset.top - margin, null, null, function () {
          if (true !== scollTimer) {
            return;
          }

          scollTimer = setTimeout(function () {
            margin = _this.getMargin(props, scrollRefElement);
            offset = store.getOffset(targetId);
            (0, _smoothScrollTo["default"])(offset.top - margin, 100);
          }, 500);
        });
      }
    });
    return _this;
  }

  var _proto = SmoothScrollLink.prototype;

  _proto.useStore = function useStore() {
    var noDelay = this.props.noDelay;
    return noDelay ? _fastScrollStore["default"] : _scrollStore["default"];
  };

  _proto.getMargin = function getMargin(props, ref) {
    var scrollRefLoc = props.scrollRefLoc,
        scrollMargin = props.scrollMargin;
    var margin = 0;

    if (ref) {
      var refOffset = (0, _getoffset["default"])(ref, false);

      switch (scrollRefLoc) {
        case 'bottom':
          margin += refOffset.bottom - refOffset.top;
          break;

        default:
        case 'top':
          break;
      }
    }

    if (!isNaN(scrollMargin)) {
      margin += scrollMargin;
    }

    margin--;
    return margin;
  };

  _proto.componentDidMount = function componentDidMount() {
    var dom = document.getElementById(this.props.scrollRefId);

    if (dom) {
      this.setState({
        scrollRefElement: dom
      });
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    resetTimer();
  };

  _proto.render = function render() {
    var props = this.props;
    var targetId = props.targetId,
        scrollRefLoc = props.scrollRefLoc,
        scrollMargin = props.scrollMargin,
        scrollRefId = props.scrollRefId,
        style = props.style,
        preventDefault = props.preventDefault,
        others = (0, _objectWithoutPropertiesLoose2["default"])(props, ["targetId", "scrollRefLoc", "scrollMargin", "scrollRefId", "style", "preventDefault"]);
    var scrollRefElement = this.state.scrollRefElement;
    var margin = this.getMargin(props, scrollRefElement);
    return /*#__PURE__*/_react["default"].createElement(_index.ScrollReceiver, (0, _extends2["default"])({
      atom: "a"
    }, others, {
      targetId: targetId,
      scrollMargin: margin,
      style: (0, _objectSpread2["default"])((0, _objectSpread2["default"])({}, Styles.link), style),
      onClick: this.handleClick
    }));
  };

  return SmoothScrollLink;
}(_react.PureComponent);

(0, _defineProperty2["default"])(SmoothScrollLink, "defaultProps", {
  scrollRefId: '',
  scrollRefLoc: 'bottom',
  preventDefault: true,
  noDelay: false
});
var _default = SmoothScrollLink;
exports["default"] = _default;
var Styles = {
  link: {
    cursor: 'pointer'
  }
};
module.exports = exports.default;