import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import _objectWithoutPropertiesLoose from "reshow-runtime/es/helpers/objectWithoutPropertiesLoose";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inheritsLoose from "reshow-runtime/es/helpers/inheritsLoose";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import React, { PureComponent } from 'react';
import get from 'get-object-value';
import { mixClass, SemanticUI } from 'react-atomic-molecule';
import scrollStore from '../../src/stores/scrollStore';
import fastScrollStore from '../../src/stores/fastScrollStore';

var _ref = /*#__PURE__*/React.createElement(SemanticUI, null);

var ScrollSpy = /*#__PURE__*/function (_PureComponent) {
  _inheritsLoose(ScrollSpy, _PureComponent);

  function ScrollSpy() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _PureComponent.call.apply(_PureComponent, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "state", {});

    return _this;
  }

  var _proto = ScrollSpy.prototype;

  _proto.getOffsetEl = function getOffsetEl() {
    if (this.el) {
      return this.el;
    } else {
      console.warn('Please use SemanticUI. props.container -> import {SemanticUI} from "react-atomic-molecule"');
    }
  };

  _proto.useStore = function useStore() {
    var noDelay = this.props.noDelay;
    return noDelay ? fastScrollStore : scrollStore;
  };

  _proto.attach = function attach() {
    if (this.useStore().hasAttach(this)) {
      return this.state.id;
    }

    var id = this.useStore().attach(this);
    this.setState({
      id: id
    });
    return id;
  };

  _proto.detach = function detach() {
    return this.useStore().detach(this);
  };

  _proto.isScrollReceiver = function isScrollReceiver(el) {
    if (get(el, ['props', 'isScrollReceiver'])) {
      return true;
    }

    return false;
  };

  _proto.componentDidMount = function componentDidMount() {
    this.attach();
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.detach();
  };

  _proto.render = function render() {
    var _this2 = this;

    /**
     * monitorScroll use in store, in component just for reset props.
     */
    var _this$props = this.props,
        className = _this$props.className,
        monitorScroll = _this$props.monitorScroll,
        children = _this$props.children,
        container = _this$props.container,
        noDelay = _this$props.noDelay,
        others = _objectWithoutPropertiesLoose(_this$props, ["className", "monitorScroll", "children", "container", "noDelay"]);

    var isScrollReceiver = this.isScrollReceiver(children);
    var targetId = this.state.id;
    var classes = mixClass(className, 'spy-tar-' + targetId);
    var cookChildren;
    var thisContainer;
    var thisProps;

    if (isScrollReceiver) {
      thisContainer = children;
      thisProps = _objectSpread(_objectSpread(_objectSpread({}, others), children.props), {}, {
        className: classes,
        targetId: targetId,
        container: container,
        noDelay: noDelay
      });
    } else {
      thisProps = _objectSpread({
        children: children,
        className: classes
      }, others);

      if (container) {
        thisContainer = container;
      } else {
        thisContainer = _ref;
      }
    }

    thisProps = _objectSpread(_objectSpread({}, thisProps), {}, {
      refCb: function refCb(el) {
        return _this2.el = el;
      }
    });
    return /*#__PURE__*/React.cloneElement(thisContainer, thisProps);
  };

  return ScrollSpy;
}(PureComponent);

_defineProperty(ScrollSpy, "defaultProps", {
  monitorScroll: true,
  noDelay: false
});

export default ScrollSpy;