import _extends from "reshow-runtime/es/helpers/extends";
import _objectSpread from "reshow-runtime/es/helpers/objectSpread2";
import _objectWithoutPropertiesLoose from "reshow-runtime/es/helpers/objectWithoutPropertiesLoose";
import _assertThisInitialized from "reshow-runtime/es/helpers/assertThisInitialized";
import _inheritsLoose from "reshow-runtime/es/helpers/inheritsLoose";
import _defineProperty from "reshow-runtime/es/helpers/defineProperty";
import React, { PureComponent } from 'react';
import smoothScrollTo from 'smooth-scroll-to';
import getOffset from 'getoffset';
import { ScrollReceiver } from '../../src/index';
import scrollStore from '../../src/stores/scrollStore';
import fastScrollStore from '../../src/stores/fastScrollStore';
var scollTimer = null;

var resetTimer = function resetTimer() {
  if (scollTimer) {
    clearTimeout(scollTimer);
    scollTimer = false;
  }
};

var SmoothScrollLink = /*#__PURE__*/function (_PureComponent) {
  _inheritsLoose(SmoothScrollLink, _PureComponent);

  function SmoothScrollLink() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _PureComponent.call.apply(_PureComponent, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "state", {
      scrollRefElement: null
    });

    _defineProperty(_assertThisInitialized(_this), "handleClick", function (e) {
      var props = _this.props;

      var store = _this.useStore();

      var preventDefault = props.preventDefault,
          targetId = props.targetId;
      var scrollRefElement = _this.state.scrollRefElement;

      if (preventDefault) {
        e.preventDefault();
      }

      resetTimer();
      var offset = store.getOffset(targetId);

      if (offset) {
        var margin = _this.getMargin(props, scrollRefElement);

        scollTimer = true;
        smoothScrollTo(offset.top - margin, null, null, function () {
          if (true !== scollTimer) {
            return;
          }

          scollTimer = setTimeout(function () {
            margin = _this.getMargin(props, scrollRefElement);
            offset = store.getOffset(targetId);
            smoothScrollTo(offset.top - margin, 100);
          }, 500);
        });
      }
    });

    return _this;
  }

  var _proto = SmoothScrollLink.prototype;

  _proto.useStore = function useStore() {
    var noDelay = this.props.noDelay;
    return noDelay ? fastScrollStore : scrollStore;
  };

  _proto.getMargin = function getMargin(props, ref) {
    var scrollRefLoc = props.scrollRefLoc,
        scrollMargin = props.scrollMargin;
    var margin = 0;

    if (ref) {
      var refOffset = getOffset(ref, false);

      switch (scrollRefLoc) {
        case 'bottom':
          margin += refOffset.bottom - refOffset.top;
          break;

        default:
        case 'top':
          break;
      }
    }

    if (!isNaN(scrollMargin)) {
      margin += scrollMargin;
    }

    margin--;
    return margin;
  };

  _proto.componentDidMount = function componentDidMount() {
    var dom = document.getElementById(this.props.scrollRefId);

    if (dom) {
      this.setState({
        scrollRefElement: dom
      });
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    resetTimer();
  };

  _proto.render = function render() {
    var props = this.props;

    var targetId = props.targetId,
        scrollRefLoc = props.scrollRefLoc,
        scrollMargin = props.scrollMargin,
        scrollRefId = props.scrollRefId,
        style = props.style,
        preventDefault = props.preventDefault,
        others = _objectWithoutPropertiesLoose(props, ["targetId", "scrollRefLoc", "scrollMargin", "scrollRefId", "style", "preventDefault"]);

    var scrollRefElement = this.state.scrollRefElement;
    var margin = this.getMargin(props, scrollRefElement);
    return /*#__PURE__*/React.createElement(ScrollReceiver, _extends({
      atom: "a"
    }, others, {
      targetId: targetId,
      scrollMargin: margin,
      style: _objectSpread(_objectSpread({}, Styles.link), style),
      onClick: this.handleClick
    }));
  };

  return SmoothScrollLink;
}(PureComponent);

_defineProperty(SmoothScrollLink, "defaultProps", {
  scrollRefId: '',
  scrollRefLoc: 'bottom',
  preventDefault: true,
  noDelay: false
});

export default SmoothScrollLink;
var Styles = {
  link: {
    cursor: 'pointer'
  }
};